package com.care.client.controller;


import com.care.client.service.DevInstallApiService;
import com.care.client.service.PassportService;
import com.care.client.vo.MemberInfoVO;
import com.care.common.util.Result;

import com.care.common.vo.device.DeviceVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

/**
 * 描述：
 *
 * @autho：wenskys
 * @create 2020/5/12 14:13
 **/
@Api(tags = "设备安装接口")
@RestController
@RequestMapping("/pinanbao/install")
public class DevInstallApiController {

    @Resource
    private DevInstallApiService devInstallApiService;
    @Resource
    private PassportService passportService;


    /**
     * 验证设备（是否存在,是否被别人绑定了）
     * @param devCode
     * @return
     */
    @PostMapping("checkDevCode")
    @ApiOperation(tags = {"首页"},value = "添加设备-验证设备 --二期新增")
    public Result<Object> checkDevCode(HttpServletRequest request, @RequestHeader("token") String token, @RequestParam("devCode") String devCode){
        MemberInfoVO current = passportService.checkToken(token);
        if (this.devInstallApiService.checkDevCode(current.getId(),devCode)){
            return  Result.success("验证成功");
        } else{
            return  Result.error("验证失败");
        }
    }

    /**
     * 绑定用户
     * @param devCode
     * @return
     */
    @PostMapping("bindUser")
    @ApiOperation(tags = {"首页"},value = "添加设备-绑定用户 --二期新增")
    public Result<Object> bindUser(HttpServletRequest request, @RequestHeader("token") String token,
                                   @RequestParam("phone") String phone,
                                   @RequestParam("devCode") String devCode) {
        if (this.devInstallApiService.bindUser(phone,devCode)) {
            return  Result.success("绑定成功");
        } else{
            return  Result.error("绑定失败");
        }
    }

    /**
     * 获取设备激活状态
     * @param devCode
     * @return
     */
    @PostMapping("getDevActiveStatus")
    @ApiOperation(tags = {"首页"},value = "添加设备-获取设备激活状态 --二期新增")
    public Result<DeviceVO> getDevActiveStatus(HttpServletRequest request, @RequestHeader("token") String token,
                                               @RequestParam("devCode") String devCode) {
        return  Result.success(this.devInstallApiService.getDevActiveStatus(devCode));
    }
}
