package com.care.client.service;



import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.care.common.entity.CareDevice;
import com.care.common.entity.CareMemberInfo;
import com.care.common.enums.DeviceActiveStatusEnum;
import com.care.common.service.CareDeviceService;
import com.care.common.service.CareMemberInfoService;
import com.care.common.vo.device.DeviceVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Slf4j
@Service
public class DevInstallApiService {

    @Resource
    private CareMemberInfoService careMemberInfoService;

    @Resource
    private CareDeviceService careDeviceService;

    public Boolean checkDevCode(Long memberId ,String devCode) {
        QueryWrapper<CareDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(CareDevice::getDevCode,devCode);
        CareDevice careDevice = this.careDeviceService.getOne(queryWrapper);
        if ( careDevice == null) { //不存在
            return false;
        } else if(careDevice.getMemberId() !=null && careDevice.getMemberId() != 0L && !careDevice.getMemberId().equals(memberId)) { //已经被别人绑定
            return false;
        }

        return true;
    }

    public Boolean bindUser(String phone ,String devCode) {
        QueryWrapper<CareMemberInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(CareMemberInfo::getPhone,phone);
        CareMemberInfo careMemberInfo = this.careMemberInfoService.getOne(queryWrapper);

        QueryWrapper<CareDevice> queryWrapper2 = new QueryWrapper<>();
        queryWrapper2.lambda().eq(CareDevice::getDevCode,devCode);
        CareDevice careDevice = this.careDeviceService.getOne(queryWrapper2);

        careDevice.setMemberId(careMemberInfo.getId());
        careDevice.setMemberPhone(phone);

        return this.careDeviceService.updateById(careDevice);
    }


    public DeviceVO getDevActiveStatus(String devCode) {
        QueryWrapper<CareDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(CareDevice::getDevCode,devCode);
        CareDevice careDevice = this.careDeviceService.getOne(queryWrapper);
        DeviceVO vo = new DeviceVO();
        vo.setActiveStatus(careDevice.getActiveStatus());
        vo.setActiveStatusName(DeviceActiveStatusEnum.getCodeToName(vo.getActiveStatus()));
        return vo;
    }

}
