package com.care.mqtt.service;


import com.care.mqtt.tool.MqttDataConnector;

import com.care.common.entity.CareDevice;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;

/**
 * @Author: stw
 * @Date: 2021/8/14
 * @Desc:
 */
@Service
public class MqttPublishService {
    @Resource
    private MqttConnectorPoolService mqttConnectorPoolService;


    /**
     * 发布消息
     */
    public boolean publish(CareDevice careDevice,String data) {
        try {

            String topic = careDevice.getTopic();
            String cliendId = careDevice.getClientId();
            if (StringUtils.isEmpty(topic) || StringUtils.isEmpty(cliendId)) {
                return false;
            }

            String publishTopic = topic.replace("event","control");
            careDevice.setTopic(publishTopic);

            MqttDataConnector mqttDataConnector = mqttConnectorPoolService.addOne(careDevice);

            mqttDataConnector.publish(publishTopic, data);

            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }

}
